
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "COM.h"


int main(void)
{
 int com;
 int i, n, p;
 char buffer[64], string[256];
 
 // apertura porta seriale
 if ((com = COM_open(1, READ, 4800, 'N', 8, 1, NO_HANDSHAKE)) > 0)
   {
    p = 0;
    while (1)
         {
          n = COM_read(com, buffer, sizeof(buffer)); // ricezione
          if (n > 0)
            {
             for (i=0; i<n; i++) // ricerca caratteri iniziale/finale
			    {
				 if (buffer[i] == '$') // carattere iniziale
				   {
					string[0] = buffer[i];
					p = 1;
				   }
				 else
				     {
					  if (buffer[i] == '\n') // carattere finale
					    {
						 string[p] = '\0'; // fine stringa
						 if (strncmp(string,"$GPGGA",6)==0)
						   {
							// stringa di tipo "GPGGA"
							printf("%s\r\n",string);
						   }
						 p = 0;
					    }
					  else // carattere intermedio
					      {
						   string[p] = buffer[i]; // copia carattere
						   p++;
					      }
				     }
				} // fine ciclo for
            } 
         } // fine ciclo while
   }
 else
     printf("Errore apertura porta seriale\r\n");
 return 0;
}
